stages:
  - test
  - build
  - deploy

default:
  image: ruby:3.0.2
  before_script:
    - gem install bundler -v 2.3.22
    - bundle install

variables:
  CI_PROJECT_NAME: gitlab-sdk # overwrite default value for `gem-release.yml` to work

specs:
  stage: test
  script:
    - bundle exec rake

styles:
  stage: test
  script:
    - bundle exec rubocop

include:
  - component: gitlab.com/gitlab-org/components/gem-release/gem-release@~latest

build_docker_example_app:
  image: docker:24.0.7-dind
  services:
    - docker:24.0.7-dind
  cache: []
  stage: build
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  before_script:
    - echo "$CI_REGISTRY_PASSWORD" | docker login "$CI_REGISTRY" -u "$CI_REGISTRY_USER" --password-stdin
  script:
    - REGISTRY="${CI_REGISTRY}/${CI_PROJECT_PATH}"
    - IMAGE="${REGISTRY}/example-app"
    - docker build -f example_app/Dockerfile -t "${IMAGE}:${CI_COMMIT_REF_SLUG}" -t "${IMAGE}:${CI_COMMIT_SHA}" .
    - docker push $IMAGE --all-tags
